#include "ctpuz.h"

.globl solve_asm
	.type	solve_asm,@function
solve_asm:
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%ebx
	pushl	%edi
	pushl	%esi

	movl	8(%ebp), %ebx
	movl	12(%ebp), %edx
#ifdef COUNT_PLACED
	movl	20(%ebp), %ebp
#endif

	notl	%ebx
	bsf	%ebx, %edi
	notl	%ebx
	jz	2f

	movl	$first_piece, %eax
	call	try_piece
	
	popl	%esi
	popl	%edi
	popl	%ebx
	popl	%ebp	
	ret

2:
	notl	%edx
	bsf	%edx, %edi
	notl	%edx
	addl	$32, %edi
	movl	$first_piece, %eax
	call	try_piece_2
	
	popl	%esi
	popl	%edi
	popl	%ebx
	popl	%ebp	
	ret

	
	# %edi: first free field
	# %edx,%ebx bitmask

	# We want to align next_rotation.  We do this by aligning
	# to next 16 byte boundary and inserting the right amount of
	# zeros. 
	.p2align 4,,15
	.byte	0,0,0,0,0,0,0,0,0,0
next_piece:
	movl	%ecx, (%eax)
	movl	%ecx, %eax
try_piece:
	movl	(%eax), %ecx
#ifdef COUNT_STEPS
	incl	ctr+40
#endif
	orl	%ecx, %ecx
	jz,pn	retract_piece
#ifdef COUNT_STEPS
	incl	ctr+44
#endif

	movl	(%ecx),%esi
	movl	%esi,(%eax)

	# eax:	pointer to prev piece
	# ecx:	pointer to compiled piece

	movl	4(%ecx,%edi,4),%esi
	subl	$4,%esi

	# esi:	&piece->rots[firstbit].pieces-4


next_rotation:
	addl	$8, %esi
#ifdef COUNT_STEPS
	incl	ctr
#endif
	testl	(%esi), %edx
	jne,pt	next_rotation
next_rot_end_1:	

#ifdef COUNT_STEPS
	incl	ctr+4
#endif
	testl   $1, -4(%esi)
	jnz,pt	next_piece
	
#ifdef COUNT_STEPS
	incl	ctr+8
#endif

	testl	-4(%esi), %ebx
	jne,pt	next_rotation


#ifdef COUNT_STEPS
	incl	ctr+12
#endif

	
next_rot_end:
#ifdef COUNT_PLACED
	incl	placedP(,%ebp,4)
	incl	%ebp
#endif
	incl	placed
	pushl	%eax
	pushl	%ecx
	pushl	%esi
	pushl	%edi
	pushl   %ebx
	pushl	%edx
	orl	-4(%esi), %ebx
	orl	(%esi), %edx

find_firstbit:		
	notl	%ebx
	bsf	%ebx, %edi
	notl	%ebx
	movl	$first_piece, %eax
	jnz	2f

	notl	%edx
	bsf	%edx, %edi
	jz,pn   found_solution
	notl	%edx
	addl	$32, %edi
	call	try_piece_2
1:	
	popl	%edx
	popl	%ebx
	popl	%edi
	popl	%esi
	popl	%ecx
	popl	%eax
#ifdef COUNT_PLACED
	decl	%ebp
#endif
	jmp	next_rotation

2:
	call	try_piece
	popl	%edx
	popl	%ebx
	popl	%edi
	popl	%esi
	popl	%ecx
	popl	%eax
#ifdef COUNT_PLACED
	decl	%ebp
#endif
	jmp	next_rotation
	

##########################################################################
# This is the same as above but optimized for the case where only the
# high 32 bits of the board are used.
##########################################################################

	
	# We want to align next_rotation.  We do this by aligning
	# to next 16 byte boundary and inserting the right amount of
	# zeros. 
	.p2align 4,,15
	.byte	0,0,0,0,0,0,0,0
	
	# %edi: first free field
	# %edx,%ebx bitmask

next_piece_2:
	movl	%ecx, (%eax)
	movl	%ecx, %eax
try_piece_2:
	movl	(%eax), %ecx
#ifdef COUNT_STEPS
	incl	ctr+48
#endif
	orl	%ecx, %ecx
	jz,pn	retract_piece
#ifdef COUNT_STEPS
	incl	ctr+52
#endif

	movl	(%ecx),%esi
	movl	%esi,(%eax)

	# eax:	pointer to prev piece
	# ecx:	pointer to compiled piece

	movl	4(%ecx,%edi,4),%esi
	testl	(%esi), %edx
	je,pn	1f

	# esi:	&piece->rots[firstbit].pieces - 4
#ifdef COUNT_STEPS
	incl	ctr+32
#endif

next_rotation_2:
	addl	$4, %esi
#ifdef COUNT_STEPS
	incl	ctr+16
#endif
	testl	(%esi), %edx
	jne,pt	next_rotation_2
1:	
next_rot_2_end_1:	
#ifdef COUNT_STEPS
	incl	ctr+20
#endif
	testl	$-1,(%esi)
	je,pt	next_piece_2
next_rot_2_end_2:	
#ifdef COUNT_STEPS
	incl	ctr+24
#endif
#ifdef COUNT_PLACED
	incl	placedP(,%ebp,4)
	incl	%ebp
#endif
	incl	placed
	pushl	%eax
	pushl	%ecx
	pushl	%esi
	pushl	%edi
	pushl	%edx
	orl	(%esi), %edx

find_firstbit_2:		
	notl	%edx
	bsf	%edx, %edi
	notl	%edx
	jz,pn	found_solution_2
	addl	$32, %edi
	movl	$first_piece, %eax
	call	try_piece_2

	popl	%edx
	popl	%edi
	popl	%esi
	popl	%ecx
	popl	%eax
#ifdef COUNT_PLACED
	decl	%ebp
#endif
	jmp	next_rotation_2

found_solution_2:	
	# %ebx:%edx is full, this must be a solution.
	incl	solutions
	popl	%edx
	popl	%edi
	popl	%esi
	popl	%ecx
	popl	%eax
#ifdef COUNT_PLACED
	decl	%ebp
#endif
	
	movl	%ecx, (%eax)

retract_piece:
	ret

found_solution:	
	# %ebx:%edx is full, this must be a solution.
	incl	solutions
	popl	%edx
	popl	%ebx
	popl	%edi
	popl	%esi
	popl	%ecx
	popl	%eax
#ifdef COUNT_PLACED
	decl	%ebp
#endif
	
	movl	%ecx, (%eax)
	ret

.Lfe10:
	.size	solve_asm,.Lfe10-solve_asm
